/*A*/ /* Head  */
/****h*  getinfo.c *********
 *
 *	NAME
 *   getinfo.c
 *
 *	FUNCTION
 *    all functions for simple information gathering
 *    about the data structures. Maybe it is useful
 *    to write here some functions for the output
 *    routine.
*
*	CREATION DATE
*	  22-Mar-1997
*
*  HISTORY
*    220397 created file with printthrow
*    080697 moved getobject from output.c
*
*  TODO
*
*  BUGS
*
*  BEAST METHODS
*    printthrow();
*    getobject();
*
                *******
*/

/* {{{ */
/* for folding recognition */
/* }}} */

/*E*/
/*-----------------------------------------*/

/*A*//*  External routines and Structures */

#include "define.h"

/*E*/

/*-----------------------------------------*/

/*A*//*  Global variables */


/*
  pointers to dynamic allocated memory
*/

extern struct OPTIONS options;	/* for some options */
extern int *siteswap;		/* external pointer for the decoded inputstring */
extern int site1;
extern int site2;
extern int **pattern;		/* pointer to array of pointers, which are pointing to an int array */
extern int patt1;		/* multiplier for array access */
extern int *objects;		/* array for object data */
extern int obje1;		/* for access */
extern int hdelay[];

/*E*/

/*-----------------------------------------*/

/*A*/ int printthrow (int pos, int person, int hand, int mult)
{
/****** getinfo.c/printthrow *********
 *
 *	NAME
 *	  printthrow
 *
 *	FUNCTION
 *    This function prints the specified throw
 *
 *  SYNOPSIS
 *    stderror = printthrow(int pos,int person,int hand,int mult)
 *
 *  RESULT
 *    0 if successful
 *
 *  BUGS
 *
 *  TODO
 *
 *  SEE ALSO
 *
 *******
 */
  int sitepos;

  hand = hand % 2;
  sitepos = (pos * 2 + hand) % options.length;


//printf("Throw: %d person: %d hand: %d\n",pos,person,hand);
  if ((*(siteswap + (site1 * (sitepos)) + (site2 * person) + (mult * 2 + 1)) % 6) == 0)
    {				/* integer throw */
      printf ("%d", *(siteswap + (site1 * (sitepos)) + (site2 * person) + (mult * 3 + 1)) / 6);
    }
  else
    {
      printf ("%2.1f", (float) *(siteswap + (site1 * (sitepos)) + (site2 * person) + (mult * 3 + 1)) / 6);
    }
  if ((*(siteswap + (site1 * (sitepos)) + (site2 * person) + (mult * 3 + 2))) % 2 == 1)
    {				/* cross */
      printf ("x");
    }
  if (*(siteswap + (site1 * (sitepos)) + (site2 * person) + (mult * 3 + 2)) > 1)
    {				/* pass */
      printf ("p");
    }
  return 0;
}
/*E*/

/*-----------------------------------------*/

/*A*/ int getobject (int pos, int mul, int pers, int hand, int mplex, int changehands[]) {

/*A*/  // blah and init:

/****** getinfo.c/getobject *********
 *
 *	NAME
 *	  getobject
 *
 *	FUNCTION
 *    This routine gets the object for output
 *
 *  SYNOPSIS
 *    object = getobject(int pos,int mul,int pers,int hand,int mplex,int changehands[])
 *
 *  RESULT
 *    number of object
 *    -1 if no object
 *    -2 for end of multiplex
 *  BUGS
 *
 *  TODO
 *    fix prologue and epilogue
 *    changehands is not used (obsolete)
 *
 *  SEE ALSO
 *
 *******
 */

  int object;
  int phand;			/* person+hand */
  int pos1;			/* pos * 6 */
  int pos2;			/* pos in array */
  int pos3;			/* pos in array starts at first catch */
  int objecthold;		/* which object is held */

  hand = (hand + options.latestthrow) % 2;
  pos = pos + options.latestthrow % 2;
  phand = pers * 2 + hand;	/* person+hand */
  pos1 = (pos * 6) + mul;	/* position */
  pos1 -= hdelay[phand];	/* sub the handdelay */
  pos2 = (((pos1 + options.swapperiod * 6) / 6) % options.swapperiod) / 2;	/* pos2 is not further used */
  pos3 = pos2 + options.latestthrow / 2;
/*E*/
/*A*/ /* prologue */
/** use the begindelay **/
  if (pos < 0) {
    if (mplex == options.objects)
      return -1;		/* exit */
    if (*(objects + mplex * obje1 + 0) == pers) {
      if (*(objects + mplex * obje1 + 1) == hand) {
	      return mplex;
	    } else {
	      return -2;
	    }
    } else {
      return -2;
    }
  }
/*E*/
/*A*/ /* epilogue */
  if (pos >= options.swapperiod) {
    if (options.swapperiod * 6 + *(objects + (mplex * obje1 + 2)) <= pos1 + hdelay[phand]) {			/* end */
      if (mplex == options.objects)
        return -1;		/* exit */
      if (*(objects + mplex * obje1 + 0) == pers) {
        if (*(objects + mplex * obje1 + 1) == hand) {
          return mplex;
        } else {
          return -2;
        }
      } else {
	      return -2;
	    }
    }
  }
/*E*/

  if (*(pattern[pos3] + (patt1 * phand) + 0) <= mplex) {				/* multiplex exceeded */
    if (options.beginwait == -1)
      return -1;		/* exit if no handhold */
    
    objecthold = mplex - *(pattern[pos3] + (patt1 * phand) + 0);
    if (objecthold == options.objects)
      return -1;		/* tested all objects -> exit */
    if ((*(objects + (objecthold * obje1 + 2))) > pos1 + hdelay[phand]) {			/* was the object thrown yet? */
      if (*(objects + objecthold * obje1 + 0) == pers) {			/* some aditional tests */
        if (*(objects + objecthold * obje1 + 1) == hand) {
          return objecthold;
        } else {
          return -2;
        }
      } else {
	      return -2;
	    }
    } else {
      return -2;		/* not this one */
    }
  }

  if (changehands[pers]) {
    if (((pos1 + 36) % 12) < 6) {			/* 36 for safety (24 would be enough) */
      if (options.beginwait == -1)
        return -1;		/* empty hand (nothing can be held here) */
      else
        return -2;
    }
  } else {
    if (((pos1 + 36) % 12) >= 6) {
      if (options.beginwait == -1)
        return -1;		/* empty hand (nothing can be held here) */
      else
        return -2;
    }
  }
//      printf("pos: %d hand: %d\n",pos3,phand);
  object = *(pattern[pos3] + (patt1 * phand) + mplex + 1);

//      printf("return : %d\n",object);
  return object;
}
/*E*/

/*-----------------------------------------*/
