/*A*//* Head  */

/****h*  input.c *********
*
*	NAME
*   input.c
*
*	FUNCTION
*    all functions for non commandline input via file 
*
*	CREATION DATE
*	  17-Mar-1997
*
*  HISTORY
*    170397 created input by file
*
*  TODO
*
*  BUGS 
*    the generation of beginnings and endings is buggy
*
*  BEAST METHODS
*    openfile()
*    readline()
*    writeline()
*
                *******
*/

/* {{{ */
/* for folding recognition */
/* }}} */

/*E*/

/*-----------------------------------------*/

/*A*//*  External routines and Structures */

#include "define.h"

/*E*/

/*-----------------------------------------*/

/*A*//*  Global variables */

/*
   pointers to dynamic allocated memory
 */

extern struct OPTIONS options;	/* for some options */
FILE *fin = NULL;		/* input Filepointer */
FILE *frate = NULL;		/* ratingfile Filepointer */
/*E*/

/*-----------------------------------------*/

/*A*/ int openfile (char *argv[])
{
/****** input.c/openfile *********
*
*	NAME
*	  openfile
*
*	FUNCTION
*    This function opens the inputfile and the ratingfile
*
*  SYNOPSIS
*    stderror = openfile(char *argv[])
*
*  RESULT
*    0=OK else stderror
*
*  BUGS
*
*  TODO
*
*  SEE ALSO
*    readline()
*
*******
*/
  if ((fin = fopen (argv[options.infile] + 2, "rb")) == NULL)
    {
      printf ("Could not open file %s for input\n", argv[options.infile] + 2);
      return 2;
    }
  if ((frate = fopen ("ram:rating.out", "wt")) == NULL)
    {
      printf ("Error: cannot create file %s \n", "ram:rating.out");
      return 2;
    }
  fprintf (frate, "Rating file generated by " PROGNAME " " VERSION "\n"
	   "1=average 2=good bad sitewaps have been deleted\n\n");
  return 0;
}
/*E*/
 
/*-----------------------------------------*/

/*A*/ int readline (char *siteswap)
{
/****** input.c/readline *********
*
*	NAME
*	  readline
*
*	FUNCTION
*    This function reads one line of input from the file
*
*  SYNOPSIS
*    result = readline(char *siteswap)
*
*  RESULT
*    unknown (number of chars read)
*
*  BUGS
*
*  TODO
*
*  SEE ALSO
*
*******
*/
  return (int) fgets (siteswap, MAXINPUTLEN, fin);
}
/*E*/

/*-----------------------------------------*/

/*A*/ int writeline (int rating, char *siteswap)
{
/****** input.c/writeline *********
*
*	NAME
*	  writeline
*
*	FUNCTION
*    This function writes a line to the ratingfile
*
*  SYNOPSIS
*    result = writeline(int rating,char *siteswap)
*
*  RESULT
*    unknown (number of chars written)
*
*  BUGS
*
*  TODO
*
*  SEE ALSO
*
*******
*/
  fprintf (frate, "%d  ", rating);
  return fputs (siteswap, frate);
}
/*E*/
