/*A*//* History, TODO und so */

/****h* main.c *********
*
*	NAME
*	  S22J
*
*	COPYRIGHT
*	  Gnu Public Licence
*
*	FUNCTION
*    Converts siteswap strings to Jongl input-files
*
*
*	AUTHOR
*	  Martin Hoffmann
*
*	CREATION DATE
*	  7-June-1997
*
*	MODIFICATION HISTORY
*	  7-June-1997 first beta version 0.99
*    1-Nov-1998 removed segfaults (WR)
*    jan/feb 2002 added something (WR) -> beta 3
*    16-mar-2002 corrected handling of , and . (WR) -> beta 4
*    2-jun-2002 added -H and -S (WR) -> beta 6
*    27-nov-2004 added solo mode (p != pass) -> beta 12 WR 
*    19-dec-2004 bugfix in convert MHSS -> beta 13 WR
*    19-mar-2005 corrected dt in long pattern with few balls -> beta 14 WR
*    04-jun-2006 included Ludwigs star.c -> beta 15 WR+LK
*
*	NOTES
*    Version 0.99 beta
*
*  BUGS 
*
*    Wrap-Around oder Periodenermittlung bei 4B34A 4C4A3 ? 22 oder 28
*    printf("Error: Internal Error Nr. 001 - sorry program lost!\n");
*
*  HISTORY
*
*     See also local history files
*
*    010397 GNU sin starts!
*    040397 divided in several parts for faster compiling
*    150397 standard siteswap without multiplex works
*    160397 7 3count passing works!
*    160397 cross passing works
*    010597 multiplex should work
*
*  TODO
*
*     siehe grep TODO *.[ch]
*     Betatesting
*     Wrap around
*     automatic commentation of generated pattern
*     Use coloured balls for different paths
*
*     asess difficulty of pattern
*     identify difficult throws
*     write manual
*
*  INPUTS
*
*    5p6p -v0213 -o6 -h2211 -l   11 1cnt Passing
*    333,3B3A3C,333,3C3B3A,333,3A3C3B Bradford 2_cnt linksrum drehend
*    3C3B3A3E3D333333D3C3B3A3E333333E3D3C3B3A333333A3E3D3C3B333333B3A3E3D3C33333  Bradford 5 Pers
*    804
*    4,5p334,5p33
*    6x4* (--> 6x4 46x)
*
*  SEE ALSO
*    mainprogram
*
*******
*/

/****** main.c/stderror *********
*
* NAME
*    Standard Returncodes of all functions
*
* DESCRIPTION
*    0: Everything is fine
*    1: Not enough memory
*    2: some sort of error occured
*
*******
*/

/* {{{ */
/* for folding recognition */
/* }}} */

/*E*/
/*-----------------------------------------*/
/*A*//*  External routines and structures */

#include "define.h"

/*E*/
/*-----------------------------------------*/
/*A*//*  Global variables */

extern FILE *fin;		/* input Filepointer */
extern FILE *fout;		/* output Filepointer */
extern FILE *frate;		/* ratingfile Filepointer */
char version[100] = "$VER:" VERSION;
/*
   pointers to dynamic allocated memory
 */
int *siteswap = NULL;		/* Pointer for the decoded inputstring */
int site1, site2;		/* Multipliers for array access of siteswap */
struct OPTIONS options ;	/* some options */

extern int **pattern;		/* used in makepattern.c */
extern int *objects;		/* used in makepattern.c */
extern int verz[];		/* Table for handdelay from precalc.c */

extern throwspec_type *throwspec;

/*E*/
/*-----------------------------------------*/
/*A*/ void exitprog ()
{

/****** main.c/exitprog *****************************
*
*  NAME
*    exitprog
*
*  SYNOPSIS
*    stderror = exitprog()
*
*  FUNCTION
*    This function frees all memory and resources
*
*  RESULT
*    stderror - zero for success, else an error code is returned
*
*  BUGS
*
*  SEE ALSO
*      freeoptions()
*
*******************************************************************/

  int count;			/* counter for freeing memory */

  if (fout)
    {
      fclose (fout);
      fout=NULL;
    }
  if (siteswap)
    {
      free (siteswap);
      siteswap=NULL;
    }
  if (pattern)
    {
      count = 0;
      while (pattern[count])
        {
          free (pattern[count]);	/* free the memory */
          count++;
        }			/* while */
      free (pattern);		/* free the memory for the pointers */
      pattern=NULL;
    }
  if (objects)
    {
      free (objects);
      objects=NULL;
    }
  if (throwspec) {
    free (throwspec);
    throwspec=NULL;
  }
}
/*E*/
/*-----------------------------------------*/
/*A*/ void freeoptions ()
{
/****** main.c/freeoptions *****************************
*
*  NAME
*    freeoptions
*
*  SYNOPSIS
*    freeoptions()
*
*  FUNCTION
*    This function frees the options
*
*  RESULT
*    none
*
*  BUGS
*
*
*******************************************************************/

  if (fin)
    {				/* only if input by file */
      fclose (fin);
      fin=NULL;
    }
  if (frate)
    {				/* only if input by file */
      fclose (frate);
      frate=NULL;
    }
}
/*E*/
/*-----------------------------------------*/
/*A*/ int main (int argc, char *argv[])
{

/****** main.c/mainprogram *****************************
*
*  NAME
*    main
*
*  SYNOPSIS
*    error = main(int, char *)
*
*  FUNCTION
*    This is the main program
*
*  RESULT
*    error - no errorcodes only messages.
*
*    	 Struktur:
*    
*       1. Speicher reservieren etc.
*       2. bergabeparameter einlesen
*       3. Handverzgerungen bestimmen
*       5. Muster erzeugen
*       6. Ausgabekopf und Parameter bestimmen
*       7. Ergebnis in Datei ausgeben
*
*  SOURCE
*/

  char start[MAXINPUTLEN] = "jongl ";
  char siteswapline[MAXINPUTLEN] = "none";
  int rating = 0;
  
  if (1)
    {
      if ( ! parseargs (argc, argv))
        {			/* read options */
          
/* input of patterns by file */
          
          if (options.infile)
            {			/* input by file */
/*A*/
              if (!openfile (argv))
                {
                  while (readline (siteswapline))
                    {
                      if (!identifystring (argv, siteswapline))
                        {	/* test passing etc... */
                          if (!parsestring (argv, siteswapline))
                            {	/* decode site-swap string */
                              if ( ! throw_spec (argv) )
                                {
                                  if (!handdelay ())
                                    {
                                      if (!makepattern ())
                                        {
                                          if (!head (argc, argv, siteswapline))
                                            {
                                              writepattern ();	/* thats the output-routine !!! */
                                              exitprog ();	/* close the output file */
                                              
                                              /* start Jongl automatically */
                                              if (!options.nostart)
                                                {
                                                  start[6] = 0;	/* terminate string (previously overwritten) [6] for jongl */
                                                  strcat (start, options.outname);
                                                  system (start);
                                                }	/* start */
                                              printf ("Your Rating for the pattern: (0=Trash 1=Average 2=Good 9=Abort)?");
                                              scanf ("%d", &rating);
                                              printf ("\n");
                                              if (rating == 9)
                                                {	/* abort */
                                                  freeoptions ();
                                                  exitprog ();	/* free resources */
                                                  return 0;
                                                }
                                              if (rating)
                                                {
                                                  writeline (rating, siteswapline);
                                                }
                                            }	/* head */
                                        }	/* makepattern */
                                    }	/* handdelay */
                                }  /* throw_spec */
                            }	/* parsestring */
                        }	/* identifystring */
                    }		/* while readline */
                }		/* openfile */
              freeoptions ();
/*E*/          
            }			/* input by file */
          else
            {			/* standard commandline input */
/*A*/              
              if ( ! identifystring (argv, NULL))
                {		/* test passing etc... */
                  if ( ! parsestring (argv, NULL))
                    {		/* decode site-swap string */
                      if ( ! throw_spec (argv) )
                        {
                          if ( ! handdelay ())
                            {
                              if ( ! makepattern ())
                                {
                                  markpath ();
                                  if (!head (argc, argv, NULL))
                                    {
                                      writepattern ();	/* thats the output-routine !!! */
                                      
//if(!fout) options.nostart=TRUE;
                                      freeoptions ();
                                      exitprog ();	/* free everything before starting jongl */
                                      
                                      /* start Jongl automatically */
                                      if ( ! options.nostart)
                                        {
                                          strcat (start, options.outname);
//fprintf(stderr,"-->%s<--\n",start);
                                          system (start);
                                        }	/* start */
                                    }	/* head */
                                }	/* makepattern */
                            }	/* handdelay */
                        }     /* throw_spec */
                    }		/* parsestring */
                }		/* identifystring */
/*E*/          
            }			/* standard input */
        }			/* parseargs */
      freeoptions ();
    }				/* getoptions */
  exitprog ();			/* free resources, if program aborts */
  return 0;			/* exit */
}				/* main() */
/*
 *  end of source
 *
 *************************
 */
/*E*/
/*-----------------------------------------*/
