/*A*//* Prototypes fr Funktionen */
/****h*  Protos.h *********
*
*	NAME
*   Prototypes
*
*	FUNCTION
*
*    Reference for the defines, stuctures and prototypes
*
*	CREATION DATE
* 	 26-Aug-1997
*
* HISTORY
*
* TODO
*
  *******
*/
/* {{{ */
/* for folding recognition */
/* }}} */
/*E*/

/*A*//* structures */
/****** protos.h/structures *****
*
*	NAME
*	  structures
*
*	FUNCTION
*    structure definition
*
* BUGS
*
* TODO
*
* SEE ALSO
*
* SOURCE
*/

#define SS_LEN 2000

struct OPTIONS
  {

    int people;			/* Number of persons */
    int objektnr;		/* Objectnumber in Jongl */
    int objects;		/* Number of objects */
    int length;			/* length of the site-swap in throws */
    int mult;			/* patternmultiplication */
    int beginwait;		/* time at start of pattern without throwing */
    int swaplength;		/* length of the siteswap in characters */
    int swapperiod;		/* Length (Period) of the generated pattern */
    int mplexmax;		/* maximum multiplexthrows at one time */
    int latestthrow;		/* time when the last object is thrown */

    int handm;			/* Nummer in argv fr Handoption */
    int infile;			/* Nummer in argv von der Input-Datei */
    int sswap;			/* Nummer in argv vom site-swap <------------- ! ! ! ! ! */
    int verz;			/* Nummer in argv fr Handverzgerungen */

/*-********** Switches (boolean) *********-*/

    int debug;			/* 1=debug on */
    int fract;			/* fractional throws */
    int hold;			/* 1=Long Handholding */
    int mark;			/* 1=marks pathes with different colours */
    int mplex;			/* 1=Multiplex */
    int nostart;		/* 1=Dont start jongl */
    int oddcross;		/* 1=throw odd passes cross */
    int sync;			/* 1=synchronous */
    int syncpass;		/* 1=synchronous pass (all hands at 0) */
    int wrap;			/* 1=generate wrap-around */

    int quiet;    /* no messages even if an error occurred */

    int fehler;
    char *outname;

    /* ----------- additional stuff from TheWerner -------*/
    double radius;
    int throwspec;  // SS_HANDS or SS_SITESWAP
    int thsp_max;   // size of throwspec[] array
    double maxheight;  // highest throw in pattern (might be 3.5)
		int all_throws_same_height;
		int multihandsiteswap;  // = no. of hands juggling this siteswap
		char inputsiteswap[SS_LEN];  // usually argv[sswap], might be changed together
															// with multihandsiteswap
		int solo_mode; // is set with -p1 -> "p" is a solo throw, no pass postfix
  };

typedef struct thsp {
  char throw;   // c,C,b
  int spin;   // SS_DEFAULT or -1...+4
  int bounce;  // SS_DEFAULT or -3...+3
  int Zrot; // [-90,+90]
} throwspec_type;

/*E*/

/*A*/ // protos

/*-************* functions.c *********************/

int ggt (int, int);
int kgv (int, int);

/*-************* getinfo.c *********************/

int printthrow (int, int, int, int);

/*-************* parameter.c *********************/

void copyright (void);
char *fracPass(double);
void help (void);
int parseargs (int, char **);
int self(int,int);

/*-************* input.c *********************/

int openfile (char **);
int readline (char *);
int writeline (int, char *);

/*-************* precalc.c ***********************/

int handdelay (void);
int identifystring (char **, char *);
int parsestring (char **, char *);
void setthrow (int *, int *, int *, int, int);
int throw_spec (char **);

/*-************* makepattern.c *******************/

int makepattern (void);

/*-************* markpath.c *******************/

void markpath (void);
int comparepath (int, int, int *);

/*-************* output.c ************************/

int getobject (int, int, int, int, int, int *);
void writepattern (void);
int head (int, char **, char *);
void writeKOT(int, int);
double compute_dt (void);
double compute_dt_int_height (int,int);

/*-************* main.c **************************/

int getoptions (void);
void exitprog (void);
void freeoptions (void);

/*-***********star.c*************************/
void star_convert(char*, char*, int);

/*-************************************/

int main (int, char **);


/*-************************************/

/*E*/
